--
-- This command generates a CSV file with the final prepared dataset for training models for the individualized architecture (model predicts single player only).
-- Execute this like "psql [connection options] -f [this script] | gzip > [DESTINATION]"
-- I shouldn't need to say this, but of course you need to first setup the database with the other SQL scripts and the v1-data utilitaries.
--  Raw size: ~290GB
--  Gzipped: ~52GB
--

SET SCHEMA ; -- PUT YOUR SCHEMA NAME HERE!

COPY (
    SELECT 
        condensed.ball_x,
        condensed.ball_y,
        condensed.ball_vx,
        condensed.ball_vy,
        condensed.l1_x,
        condensed.l1_y,
        condensed.l1_body,
        condensed.l1_vx,
        condensed.l1_vy,
        condensed.l1_dash_power_rate,
        condensed.l1_effort_min,
        condensed.l1_effort_max,
        condensed.l1_extra_stamina,
        condensed.l1_inertia_moment,
        condensed.l1_kick_rand,
        condensed.l1_kickable_margin,
        condensed.l1_player_decay,
        condensed.l2_x,
        condensed.l2_y,
        condensed.l2_body,
        condensed.l2_vx,
        condensed.l2_vy,
        condensed.l2_dash_power_rate,
        condensed.l2_effort_min,
        condensed.l2_effort_max,
        condensed.l2_extra_stamina,
        condensed.l2_inertia_moment,
        condensed.l2_kick_rand,
        condensed.l2_kickable_margin,
        condensed.l2_player_decay,
        condensed.l3_x,
        condensed.l3_y,
        condensed.l3_body,
        condensed.l3_vx,
        condensed.l3_vy,
        condensed.l3_dash_power_rate,
        condensed.l3_effort_min,
        condensed.l3_effort_max,
        condensed.l3_extra_stamina,
        condensed.l3_inertia_moment,
        condensed.l3_kick_rand,
        condensed.l3_kickable_margin,
        condensed.l3_player_decay,
        condensed.l4_x,
        condensed.l4_y,
        condensed.l4_body,
        condensed.l4_vx,
        condensed.l4_vy,
        condensed.l4_dash_power_rate,
        condensed.l4_effort_min,
        condensed.l4_effort_max,
        condensed.l4_extra_stamina,
        condensed.l4_inertia_moment,
        condensed.l4_kick_rand,
        condensed.l4_kickable_margin,
        condensed.l4_player_decay,
        condensed.l5_x,
        condensed.l5_y,
        condensed.l5_body,
        condensed.l5_vx,
        condensed.l5_vy,
        condensed.l5_dash_power_rate,
        condensed.l5_effort_min,
        condensed.l5_effort_max,
        condensed.l5_extra_stamina,
        condensed.l5_inertia_moment,
        condensed.l5_kick_rand,
        condensed.l5_kickable_margin,
        condensed.l5_player_decay,
        condensed.l6_x,
        condensed.l6_y,
        condensed.l6_body,
        condensed.l6_vx,
        condensed.l6_vy,
        condensed.l6_dash_power_rate,
        condensed.l6_effort_min,
        condensed.l6_effort_max,
        condensed.l6_extra_stamina,
        condensed.l6_inertia_moment,
        condensed.l6_kick_rand,
        condensed.l6_kickable_margin,
        condensed.l6_player_decay,
        condensed.l7_x,
        condensed.l7_y,
        condensed.l7_body,
        condensed.l7_vx,
        condensed.l7_vy,
        condensed.l7_dash_power_rate,
        condensed.l7_effort_min,
        condensed.l7_effort_max,
        condensed.l7_extra_stamina,
        condensed.l7_inertia_moment,
        condensed.l7_kick_rand,
        condensed.l7_kickable_margin,
        condensed.l7_player_decay,
        condensed.l8_x,
        condensed.l8_y,
        condensed.l8_body,
        condensed.l8_vx,
        condensed.l8_vy,
        condensed.l8_dash_power_rate,
        condensed.l8_effort_min,
        condensed.l8_effort_max,
        condensed.l8_extra_stamina,
        condensed.l8_inertia_moment,
        condensed.l8_kick_rand,
        condensed.l8_kickable_margin,
        condensed.l8_player_decay,
        condensed.l9_x,
        condensed.l9_y,
        condensed.l9_body,
        condensed.l9_vx,
        condensed.l9_vy,
        condensed.l9_dash_power_rate,
        condensed.l9_effort_min,
        condensed.l9_effort_max,
        condensed.l9_extra_stamina,
        condensed.l9_inertia_moment,
        condensed.l9_kick_rand,
        condensed.l9_kickable_margin,
        condensed.l9_player_decay,
        condensed.l10_x,
        condensed.l10_y,
        condensed.l10_body,
        condensed.l10_vx,
        condensed.l10_vy,
        condensed.l10_dash_power_rate,
        condensed.l10_effort_min,
        condensed.l10_effort_max,
        condensed.l10_extra_stamina,
        condensed.l10_inertia_moment,
        condensed.l10_kick_rand,
        condensed.l10_kickable_margin,
        condensed.l10_player_decay,
        condensed.l11_x,
        condensed.l11_y,
        condensed.l11_body,
        condensed.l11_vx,
        condensed.l11_vy,
        condensed.l11_dash_power_rate,
        condensed.l11_effort_min,
        condensed.l11_effort_max,
        condensed.l11_extra_stamina,
        condensed.l11_inertia_moment,
        condensed.l11_kick_rand,
        condensed.l11_kickable_margin,
        condensed.l11_player_decay,
        condensed.r1_x,
        condensed.r1_y,
        condensed.r1_body,
        condensed.r1_vx,
        condensed.r1_vy,
        condensed.r1_dash_power_rate,
        condensed.r1_effort_min,
        condensed.r1_effort_max,
        condensed.r1_extra_stamina,
        condensed.r1_inertia_moment,
        condensed.r1_kick_rand,
        condensed.r1_kickable_margin,
        condensed.r1_player_decay,
        condensed.r2_x,
        condensed.r2_y,
        condensed.r2_body,
        condensed.r2_vx,
        condensed.r2_vy,
        condensed.r2_dash_power_rate,
        condensed.r2_effort_min,
        condensed.r2_effort_max,
        condensed.r2_extra_stamina,
        condensed.r2_inertia_moment,
        condensed.r2_kick_rand,
        condensed.r2_kickable_margin,
        condensed.r2_player_decay,
        condensed.r3_x,
        condensed.r3_y,
        condensed.r3_body,
        condensed.r3_vx,
        condensed.r3_vy,
        condensed.r3_dash_power_rate,
        condensed.r3_effort_min,
        condensed.r3_effort_max,
        condensed.r3_extra_stamina,
        condensed.r3_inertia_moment,
        condensed.r3_kick_rand,
        condensed.r3_kickable_margin,
        condensed.r3_player_decay,
        condensed.r4_x,
        condensed.r4_y,
        condensed.r4_body,
        condensed.r4_vx,
        condensed.r4_vy,
        condensed.r4_dash_power_rate,
        condensed.r4_effort_min,
        condensed.r4_effort_max,
        condensed.r4_extra_stamina,
        condensed.r4_inertia_moment,
        condensed.r4_kick_rand,
        condensed.r4_kickable_margin,
        condensed.r4_player_decay,
        condensed.r5_x,
        condensed.r5_y,
        condensed.r5_body,
        condensed.r5_vx,
        condensed.r5_vy,
        condensed.r5_dash_power_rate,
        condensed.r5_effort_min,
        condensed.r5_effort_max,
        condensed.r5_extra_stamina,
        condensed.r5_inertia_moment,
        condensed.r5_kick_rand,
        condensed.r5_kickable_margin,
        condensed.r5_player_decay,
        condensed.r6_x,
        condensed.r6_y,
        condensed.r6_body,
        condensed.r6_vx,
        condensed.r6_vy,
        condensed.r6_dash_power_rate,
        condensed.r6_effort_min,
        condensed.r6_effort_max,
        condensed.r6_extra_stamina,
        condensed.r6_inertia_moment,
        condensed.r6_kick_rand,
        condensed.r6_kickable_margin,
        condensed.r6_player_decay,
        condensed.r7_x,
        condensed.r7_y,
        condensed.r7_body,
        condensed.r7_vx,
        condensed.r7_vy,
        condensed.r7_dash_power_rate,
        condensed.r7_effort_min,
        condensed.r7_effort_max,
        condensed.r7_extra_stamina,
        condensed.r7_inertia_moment,
        condensed.r7_kick_rand,
        condensed.r7_kickable_margin,
        condensed.r7_player_decay,
        condensed.r8_x,
        condensed.r8_y,
        condensed.r8_body,
        condensed.r8_vx,
        condensed.r8_vy,
        condensed.r8_dash_power_rate,
        condensed.r8_effort_min,
        condensed.r8_effort_max,
        condensed.r8_extra_stamina,
        condensed.r8_inertia_moment,
        condensed.r8_kick_rand,
        condensed.r8_kickable_margin,
        condensed.r8_player_decay,
        condensed.r9_x,
        condensed.r9_y,
        condensed.r9_body,
        condensed.r9_vx,
        condensed.r9_vy,
        condensed.r9_dash_power_rate,
        condensed.r9_effort_min,
        condensed.r9_effort_max,
        condensed.r9_extra_stamina,
        condensed.r9_inertia_moment,
        condensed.r9_kick_rand,
        condensed.r9_kickable_margin,
        condensed.r9_player_decay,
        condensed.r10_x,
        condensed.r10_y,
        condensed.r10_body,
        condensed.r10_vx,
        condensed.r10_vy,
        condensed.r10_dash_power_rate,
        condensed.r10_effort_min,
        condensed.r10_effort_max,
        condensed.r10_extra_stamina,
        condensed.r10_inertia_moment,
        condensed.r10_kick_rand,
        condensed.r10_kickable_margin,
        condensed.r10_player_decay,
        condensed.r11_x,
        condensed.r11_y,
        condensed.r11_body,
        condensed.r11_vx,
        condensed.r11_vy,
        condensed.r11_dash_power_rate,
        condensed.r11_effort_min,
        condensed.r11_effort_max,
        condensed.r11_extra_stamina,
        condensed.r11_inertia_moment,
        condensed.r11_kick_rand,
        condensed.r11_kickable_margin,
        condensed.r11_player_decay,
        self_state.x as self_x,
        self_state.y as self_y,
        self_state.body as self_body,
        self_state.vx as self_vx,
        self_state.vy as self_vy,
        self_type.dash_power_rate as self_dash_power_rate,
        self_type.effort_min as self_effort_min,
        self_type.effort_max as self_effort_max,
        self_type.extra_stamina as self_extra_stamina,
        self_type.inertia_moment as self_inertia_moment,
        self_type.kick_rand as self_kick_rand,
        self_type.kickable_margin as self_kickable_margin,
        self_type.player_decay as self_player_decay,
        self_command.playercommand_type,
        dash_command.dash_power,
        dash_command.dash_direction,
        turn_command.turn_moment,
        kick_command.kick_power,
        kick_command.kick_direction,
        tackle_command.tackle_direction
    FROM 
        shuffled_condensed_matchstates as condensed 
        JOIN playerstates as self_state
            ON self_state.matchstate_id_fk = condensed.matchstate_id
            AND self_state.teamname = 'HELIOS2019'
            AND self_state.unum != 1
        JOIN playertypes as self_type
            ON self_type.playertype_id = self_state.playertype_id_fk
        JOIN playercommands as self_command
            ON self_command.playerstate_id_fk = self_state.playerstate_id
        LEFT JOIN dash_commands as dash_command
            ON dash_command.dash_id = self_command.playercommand_id
        LEFT JOIN turn_commands as turn_command
            ON turn_command.turn_id = self_command.playercommand_id
        LEFT JOIN kick_commands as kick_command
            ON kick_command.kick_id = self_command.playercommand_id
        LEFT JOIN tackle_commands as tackle_command
            ON tackle_command.tackle_id = self_command.playercommand_id
) TO  STDOUT WITH (FORMAT CSV, HEADER, DELIMITER ',', ENCODING 'UTF8'); -- Copy to STDOUT so we can pipe it into a gzip compressor
